package com.xkl.cdl.adapter

import android.annotation.SuppressLint
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentActivity
import androidx.viewpager2.adapter.FragmentStateAdapter
import java.util.*

/**
 * author suliang
 * create 2022/3/18 10:41
 * Describe:  ViewPager适配器基类
 */
class ViewPagerAdapter : FragmentStateAdapter {

    constructor(fragmentActivity: FragmentActivity) : super(fragmentActivity)

    constructor(fragment: Fragment) : super(fragment)

    constructor(fragmentActivity: FragmentActivity, fragments: MutableList<Fragment>) : super(fragmentActivity) {
        mFragments.addAll(fragments)
    }

    constructor(fragment: Fragment, fragments: MutableList<Fragment>) : super(fragment) {
        mFragments.addAll(fragments)
    }

    private var mFragments = mutableListOf<Fragment>()

    override fun createFragment(position: Int): Fragment {
        return mFragments[position]
    }

    override fun getItemCount(): Int {
        return mFragments.size
    }

    fun getItem(position: Int): Fragment {
        return mFragments[position]
    }

    @SuppressLint("NotifyDataSetChanged")
    fun setData(fragments: MutableList<Fragment>) {
        mFragments.clear()
        mFragments.addAll(fragments)
    }
}