package com.xkl.cdl.module.m_center_learn

import android.os.Bundle
import androidx.lifecycle.ViewModel
import androidx.lifecycle.ViewModelProvider
import com.suliang.common.Config
import com.suliang.common.base.fragment.BaseFragmentVM
import com.suliang.common.util.LogUtil
import com.xkl.cdl.databinding.FragmentCoursePackBinding
import com.xkl.cdl.module.main.MainActivityViewModel

/**
 * 学习中心 子tab 下的详情课程
 * @property mainViewModel MainActivityViewModel
 */
class CoursePackFragment : BaseFragmentVM<FragmentCoursePackBinding,CoursePackFragmentViewModel>() {



    companion object {
        @JvmStatic
        fun newInstance(projectId: Long) = CoursePackFragment().apply {
            arguments = Bundle().apply {
                putLong(Config.INTENT_1,projectId)
            }
        }
    }

    override fun initViewModel(): CoursePackFragmentViewModel {
        val projectId = requireArguments().getLong(Config.INTENT_1)
        return ViewModelProvider(this,ViewModelFactory(projectId)).get(CoursePackFragmentViewModel::class.java).apply {
            this.mainActivityViewModel = ViewModelProvider(requireActivity()).get(MainActivityViewModel::class.java)
            this.learnCenterFragmentViewModel = ViewModelProvider(requireParentFragment()).get(LearnCenterFragmentViewModel::class.java)
        }
    }


    override fun initFragment() {

        vm.learnCenterFragmentViewModel.mCoursePackSearchLiveData.observe(this){
            LogUtil.e("课程包列表监听到搜索内容改变: ${vm.projectId}")
        }

    }

    override fun loadData() {

    }




    /** ViewModle 工厂类，提供传参 */
    inner class ViewModelFactory(private val projectId:Long): ViewModelProvider.Factory{
        @Suppress("UNCHECKED_CAST")
        override fun <T : ViewModel?> create(modelClass: Class<T>): T {
            return CoursePackFragmentViewModel(projectId) as T
        }
    }

}