package com.suliang.common.base

import android.graphics.drawable.AnimationDrawable
import com.suliang.common.Config
import com.suliang.common.databinding.LoadingFragmentBinding

/**
 * author suliang
 * create 2022/3/17 15:53
 * Describe: 加载等待弹窗
 */
class LoadingDialog :  BaseDialogFragment<LoadingFragmentBinding>() {

    companion object{
        @JvmStatic
        fun newInstance(msg : String): LoadingDialog {
           return LoadingDialog().apply {
                arguments?.putString(Config.INTENT_1,msg)
            }
        }
    }

    override fun initFragment() {
        //外部设置
        arguments?.getString(Config.INTENT_1,null)?.let {
            binding.loadText.text = it
        }

        //开始动画
        (binding.loadImage.drawable as AnimationDrawable).start()
    }

    override fun isTransparent(): Boolean {
        return true
    }


}