package com.suliang.common.base.activity

import androidx.viewbinding.ViewBinding
import com.suliang.common.base.viewmodel.BaseViewModel

/**
 * Activity DataBinding 与 ViewModel基类，封装DataBinding和ViewModel
 * @property VB : ViewDataBinding
 * @property VM:  ViewModel
 */
//abstract class BaseActivityVM<VB : ViewDataBinding, VM : AndroidViewModel> : BaseActivity<VB>() {
abstract class BaseActivityVM<VB : ViewBinding, VM : BaseViewModel> : BaseActivity<VB>() {

    lateinit var vm: VM
        private set


    override fun setLayoutBefore() {
        super.setLayoutBefore()
        vm = initViewModel()
    }

    override fun setLayoutAfter() {
        super.setLayoutAfter()
        lifecycle.addObserver(vm)

        vm.pageEvent.observe(this) { startActivity(it) }
        vm.toastEvent.observe(this){ showToast(it) }
        vm.loadingEvent.observe(this) { showHideLoading(it)}

    }

    abstract fun initViewModel(): VM


}
