package com.suliang.common.base.fragment

import androidx.databinding.ViewDataBinding
import androidx.lifecycle.ViewModel
import androidx.viewbinding.ViewBinding
import com.suliang.common.base.viewmodel.BaseViewModel

/**
 * Fragment DataBinding 与 ViewModel基类，封装DataBinding和ViewModel  自带懒加载
 * @property VB : ViewDataBinding
 * @property VM:  ViewModel
 */
abstract class BaseFragmentVM<VB : ViewBinding, VM : BaseViewModel> : BaseFragment<VB>() {
    lateinit var vm: VM

    override fun initFirst() {
        vm = initViewModel()
        vm.pageEvent.observe(this) { startActivity(it) }
        vm.toastEvent.observe(this){ showToast(it) }
        vm.loadingEvent.observe(this) { showHideLoading(it)}
    }

    abstract fun initViewModel(): VM
}
