package com.suliang.common.extension

import android.net.Uri
import android.widget.ImageView
import com.suliang.common.util.image.ImageLoader
import com.suliang.common.util.image.ImageLoaderOption
import java.io.File

/**
 * author suliang
 * create 2022/3/15 9:48
 * Describe:  图片加载扩展
 */
fun ImageView.loadImage(option:ImageLoaderOption){
    ImageLoader.loadImage(option)
}
fun ImageView.loadImage(url: String){
    ImageLoader.loadImage(this,url)
}
fun ImageView.loadImage(file: File){
    ImageLoader.loadImage(this,file)
}
fun ImageView.loadImage(resourceId:Int){
    ImageLoader.loadImage(this,resourceId)
}
fun ImageView.loadImage(uri: Uri){
    ImageLoader.loadImage(this,uri)
}