package com.suliang.common.util.image

import android.content.Context
import android.graphics.Bitmap
import android.graphics.drawable.Drawable
import android.net.Uri
import android.widget.ImageView
import androidx.annotation.DrawableRes
import com.bumptech.glide.Glide
import com.bumptech.glide.request.target.Target
import com.suliang.common.R
import java.io.File
import java.net.URL

/**
 * author suliang
 * create 2022/3/14 10:27
 * Describe:  图片加载配置,所有配置信息都放入这里面
 */
class ImageLoaderOption {

    //占位符
    //选项: RequestBuilder、 RequestOption、
    //变换: 改变加载的图片 Transformations 可以获取资源并修改它，然后返回被修改后的资源。通常变换操作是用来完成剪裁或对位图应用过滤器，但它也可以用于转换GIF动画，甚至自定义的资源类型。
            // fitCenter()  centerCrop()  CircleCrop()  transform(.....)
    //目标: Target 是介于请求和请求者之间的中介者的角色。Target 负责展示占位符，加载资源，并为每个请求决定合适的尺寸

    //过渡
    //配置
    //缓存
    //资源重用




    /** 上下文 */
    var context : Context? = null
    /** 目标view */
    var targetView: ImageView? = null


    /** 占位符是当请求正在执行时被展示的 Drawable 。*/
    var placeholderResId: Int = 0
    /** 错误符：  在请求永久性失败时展示。error Drawable 同样也在请求的url/model为 null ，且并没有设置 fallback Drawable 时展示*/
    var errorResId: Int = 0
    /** 后备回调符 :  在请求的url/model为 null 时展示  主要目的是允许用户指示 null 是否为可接受的正常情况*/
    var fallback : Int = 0

    //资源必须设置一样
    var bitmap : Bitmap? = null
    var drawable : Drawable ? = null
    var url: String ? = null
    var uri : Uri ? = null
    var file : File ? = null
    var resourceId : Int = 0
    var byteArray : ByteArray ? = null

//    var asDrawable : Boolean = true     //默认
    var asBitmap : Boolean  = false
    var asGif : Boolean = false
    var asFile: Boolean = false


    /**是否居中裁剪: 默认*/
//    var centerCropEnable: Boolean = false
    /** 居中全显 */
    var centerInsideEnable: Boolean = false
    var fitCenterEnable: Boolean = false

    //圆角px值
    var rounderCorners : Int = 0
    //是否模糊
    var blurEanble : Boolean  = false
    //是否圆形图片
    var circleEnable : Boolean = false


    //fitCenter
    //RequestOption
    //target
    //后台  FutureTarget<Bitemap> f = Glide.with(context).asBitmap().load(url).submit(width,height);   f.get()    //   Glide.with(context).clear(f)


//    ImageView的自动变换
//    在Glide中，当你为一个 ImageView 开始加载时，Glide可能会自动应用 FitCenter 或 CenterCrop ，这取决于view的 ScaleType 。
//    如果 scaleType 是 CENTER_CROP , Glide 将会自动应用 CenterCrop 变换。
//    如果 scaleType 为 FIT_CENTER 或 CENTER_INSIDE ，Glide会自动使用 FitCenter 变换。
//    当然，你总有权利覆写默认的变换，只需要一个带有 Transformation 集合的 RequestOptions 即可。另外，你也可以通过使用 dontTransform() 确保不会自动应用任何变换。





}