package com.suliang.common.util.media

/**
 * author suliang
 * create 2022/3/8 16:41
 * Describe: MediaPlayer定义的状态
 */
enum class EMediaState {
    /**空置状态：设置了监听挺，mediaPlayer进行了初始化，但没有设置数据 */
    IDLE,
    /** 初始状态： 在idle后，设置了数据源的状态 */
    INITIALIZED ,
    /** 准备状态：设置数据源后,调用了 prepareAsync()方法 */
    PREPARING,
    /**  准备状态：可以开始播放了 */
    PREPARED ,
    /** 调用了播放，进入运行状态 */
    RUNNING,
    /** 暂停 */
    PAUSE,
    /** 停止 */
    STOP,
    /** 播放完成状态 */
    COMPLETE,
    /** 错误状态 */
    ERROR

}