package com.suliang.common.util.media

/**
 * author suliang
 * create 2022/3/10 17:20
 * Describe:  MediaPlayer管理类
 * 不要直接调用MPUtil
 *
 */
object MPManager:IMP {

    private val mpUtil : IMP = MPUtil()

    override fun play(url: String, position: Int, listener: IMPListener?) {
        mpUtil.play(url,position,listener)
    }

    override fun pausePlay() {
        mpUtil.pausePlay()
    }

    override fun continuePlay() {
        mpUtil.continuePlay()
    }

    override fun stopPlay() {
        mpUtil.stopPlay()
    }

    override fun destroyPlay() {
        mpUtil.destroyPlay()
    }

    override fun seekTo(targetPosition: Int) {
        mpUtil.seekTo(targetPosition)
    }

    override fun seekToEnable(): Boolean {
        return mpUtil.seekToEnable()
    }

    override fun getPlayPath(): String {
        return mpUtil.getPlayPath()
    }

    override fun getDuration(): Int {
        return mpUtil.getDuration()
    }

    override fun getCurrentPosition(): Int {
        return mpUtil.getCurrentPosition()
    }

    override fun isPlaying(): Boolean {
        return mpUtil.isPlaying()
    }

    override fun getMediaState(): EMediaState {
        return mpUtil.getMediaState()
    }

    override fun addPlayListener(listener: IMPListener) {
        mpUtil.addPlayListener(listener)
    }

    override fun removePlayListener() {
        mpUtil.removePlayListener()
    }


}